Subject: [PATCH v3 02/31] arm64: Kernel booting and initialisation

From: [email-masked] (Catalin Marinas)
Date: Mon, 10 Sep 2012 15:53:29 +0100

On Mon, Sep 10, 2012 at 03:48:20PM +0100, Arnd Bergmann wrote:
> On Monday 10 September 2012, Nicolas Pitre wrote:
> > On Mon, 10 Sep 2012, Arnd Bergmann wrote:
> > > On Monday 10 September 2012, Catalin Marinas wrote:
> > > > On Mon, Sep 10, 2012 at 06:53:39AM +0100, Jean-Christophe PLAGNIOL-VILLARD wrote:
> > > I think a bunch of other architectures can have relocatable kernels, which
> > > is useful e.g. for kdump. It does imply a small runtime cost and may have
> > > other disadvantages though.
> > 
> > Relocatable in physical space is what kdump actually needs, and that's 
> > what we already have here (as well as on ARM32 for that matter with 
> > CONFIG_ARM_PATCH_PHYS_VIRT).  Relocatable in the virtual space is costly 
> > and we shouldn't need to go there.
> 
> Ah, I see. I thought that the other architectures (powerpc and x86)
> doing this were actually building with -fPIC, but they do the same
> kind of early patching that we do.

On arm64 I don't have run-time code patching (yet) but a PHYS_OFFSET
variable set at boot time. It may prove useful to have run-time code
patching but that's just an optimisation that can be added later.

-- 
Catalin